Subject: Re: [Patch] mpc5200b: improve baud rate calculation (reach high baud rates, better accuracy)

From: "Albrecht Dreß" <[email-masked]>
Date: Tue, 2 Mar 2010 09:56:48 +0100 (CET)

Hi Wolfram:

[snip]
> > Yes, but I do all /calculations/ with the /4 prescaler for higher
> accuracy.
> > If the divisor exceeds the available 16 bits of the counter reg, I round
> > (divisor / 8) to use the /32 prescaler.  Think of a 19-bit counter value,
> > where I can choose to use either the lower or the higher 16 bits for the
> > counter reg.
> 
> Okay, now I got it. (Maybe this is an indication for another comment above
> the
> set divisor function?)

O.k., I will add that comment...

> > Remember also that using the higher 16 bits (/32 prescaler) is
> > probably the exceptional case - with an IPB frequency of 132 MHz this
> will
> > happen only for standard baud rates B300 and slower.
> 
> Even the rare cases have to be correct ;)

I agree - will make the debug output and comments clearer...

[snip]
> > > This should be handled using a new compatible-entry
> > > "fsl,mpc5200b-psc-uart".
> > 
> 
> > I agree that this would be a lot cleaner, but it's also a lot more
> intrusive.
> > CC'ing the device tree discussion list here... comments, please!!
> 
> Why intrusive? Maybe I miss something?

Not for the source file, but for all the dts files, if they want to benefit from the detection of the '5200B.  Basically, *all* files have to be checked and touched if necessary.  Again, I agree that this would be the clean approach, but I wanted to avoid that effort.  Grant???

[snip]
> Leave those two function pointers empty and fill them during probe (probe
> has
> access to the compatible-property it was matched against, see its
> arguments).
> So it should be a matter of:
> 
> if (matched_property == 5200b)
> 	ops->func = this_one;
> else
> 	ops->func = that_one;

Umm, yes, that's true of course.  Will pick it up.

Thanks, Albrecht.

Tolle Dekolletés oder scharfe Tatoos? Vote jetzt ... oder mach selbst mit und zeige Deine Schokoladenseite
bei Topp oder Hopp von Arcor: http://www.arcor.de/rd/footer.toh